﻿Imports System
Imports System.Web
Imports System.Web.UI
Imports System.Collections.Specialized
Imports System.Reflection

<Assembly: AssemblyKeyFile("Auth.snk")>  
<Assembly: AssemblyVersion("1.0.0.0")> 

Namespace Charles

	Public Class AuthEventArgs
		Inherits EventArgs
		Public IsValid As Boolean = False
		Public Sub New(ByVal blnValid As Boolean)
			MyBase.New()
			IsValid = blnValid
		End Sub
	End Class

	Public Class Auth
		Inherits Control
		Implements IPostBackDataHandler, IPostBackEventHandler

		Private m_UserID As String = ""
		Private m_UserPWD As String = ""
		Public Event Result(ByVal sender As Object, e As AuthEventArgs)

		Public Property UserID() As String
			Get
				Return m_UserID
			End Get
			Set(ByVal Value As String)
				Value = Value.Replace("'", "_") '不允許輸入
				Value = Value.Replace(";", "_") '單引號, 分
				Value = Value.Replace(" ", "_") '號或是底線
				m_UserID = Value.ToLower()      '帳號不分大小寫
			End Set
		End Property

		Public Property UserPWD() As String
			Get
				Return m_UserPWD
			End Get
			Set(ByVal Value As String)
				Value = Value.Replace("'", "_") '不允許輸入
				Value = Value.Replace(";", "_") '單引號, 分
				Value = Value.Replace(" ", "_") '號或是底線
				m_UserPWD = Value.ToLower()     '密碼不分大小寫
			End Set
		End Property

		'產生使用者介面的程序
		Protected Overrides Sub Render(ByVal Output As HtmlTextWriter)

			Output.Write("帳號: <input name=" & Me.UniqueID & _
						 " id=UserID type=text value=" & Me.m_UserID & "><br>")
			Output.Write("密碼: <input name=" & Me.UniqueID & _
						 " id=UserPWD type=password><br>")
			Output.Write("<input type=Reset value=重置>  ")
			Output.Write("<input type=button value=確定 " & _
						 "OnClick=""JavaScript:" & _
						 Page.GetPostBackEventReference(Me) & """>")
						'取得將控制項在 Client 端的ID, 並製作 PostBack 的 JavaScript
		End Sub

		'下列程序用來載入傳回的資料, 並且決定要不要執行 RaisePostBackEvent 程序
		Public Overridable Function LoadPostData( _
															 ByVal PostDataKey As String, _
															 ByVal Values As NameValueCollection) As Boolean _
															 Implements IPostBackDataHandler.LoadPostData
			'PostDataKey 參數存放傳回資料的控制項在 Client 端的 ID
			'Values 參數則存放了所有控制項所存放的資料

			'假設使用者輸入帳號為 charles 密碼為 pass ,則
			'在兩個 Text 中 Box 中所輸入的資料會以 charles,pass 的方式傳回

			Dim strValues As String = Values(PostDataKey)    '取得控制項的傳回參數
			Dim intIndex As Integer = strValues.IndexOf(",") '取得逗號所在位置
			
			'下列兩行敘述分別取得使用者所輸入的帳號及密碼
			m_UserID = strValues.SubString(0 , intIndex)
			m_UserPWD = strValues.SubString(intIndex + 1, strValues.Length - intIndex - 1)
			Return True  '執行 RaisePostBackEvent 程序
		End Function

		'當控制項的資料有所改變的時候, 用來通知 ASP.NET
		Public Overridable Sub RaisePostDataChangedEvent() _
													 Implements IPostBackDataHandler.RaisePostDataChangedEvent
			'沒有任何實作的程式碼, 由於實作了IpostBackDataHandler介面, 所以必需宣告
		End Sub

		'用來引發事件的程序
		Public Overridable Sub RaisePostBackEvent(ByVal EventArgument As String) _
													 Implements IPostBackEventHandler.RaisePostBackEvent

			'此段區塊可以放置檢查資料源是否有該使用者資料

			If m_UserID="charles" AndAlso m_UserPWD="pass" Then
				RaiseEvent Result(Me, New AuthEventArgs(True))
			Else
				RaiseEvent Result(Me, New AuthEventArgs(False))
			End If
		End Sub
	End Class
End Namespace